/******************************************************************************
*	
*	[Title]	
*
*	[Model] 	PocketViewer
*
*	[Version]	Ver1.00
*
*	Copyright (C) 1997 CASIO COMPUTER CO.,LTD. All rights reserved.
******************************************************************************/
#include	<stdrom.h>

#include	"define.h"
#include	"libc.h"
#include	"L_define.h"
#include	"L_libc.h"

#define MAX_LEVEL 8

#define MAX_DIMEN 10

#include	"life.h"

/***  ***/
static void PuzzleInit( void );
void PuzzleDisplay(void);
static void PuzzleTchSet(void);
static void DataInit( struct work_area *p );
static void DispHSData(void);
static void Disp( struct work_area *p, bool f );
static void DispCard( int x, int y, int n, bool f );
static void DrawFish( TCHSTS *tsts );
static int GetSeed( void );
static void Num2( byte *p, int n );
static void TimeChg(byte *time,int hightime);
static void GameSet(void);
static void DimenSet(void);
void GmPdwnSet(void);
bool PdwnFncSys(word sel);
bool GmPdwnFnc();
void NextPosition(void);
static void set_cur_size(int sz);


TCHTBL far TchHeaderIcon[] = {
	99, 0, 127, 11,
	ACT_MAKE | ACT_MOVE_IN | ACT_MOVE_OUT | ACT_BREAK_IN,
	OBJ_IC_NEW,
	0x0000,

	71, 0, 98, 11,
	ACT_MAKE | ACT_MOVE_IN | ACT_MOVE_OUT | ACT_BREAK_IN,
	OBJ_IC_SIZE,
	0x0000,

	31, 0,70, 11,
	ACT_MAKE | ACT_MOVE_IN | ACT_MOVE_OUT | ACT_BREAK_IN,
	OBJ_IC_DIMEN,
	0x0000,

	1, 0,30, 11,
	ACT_MAKE | ACT_MOVE_IN | ACT_MOVE_OUT | ACT_BREAK_IN,
	OBJ_IC_START,
	0x0000,

	0, 0, 0, 0,
	ACT_NONE,
	OBJ_END,
	0x0000
};

T_ICON far TiconNew      = { &TchHeaderIcon[0], NULL, NULL, 0x00 };
T_ICON far TiconSize 	 = { &TchHeaderIcon[1], NULL, NULL, 0x00 };
T_ICON far TiconDimen    = { &TchHeaderIcon[2], NULL, NULL, 0x00 };
T_ICON far TiconStart    = { &TchHeaderIcon[3], NULL, NULL, 0x00 };


TCHTBL far TchGameArea[] = {     /* GameArea Level1 */
	START_SCR_X, START_SCR_Y,
	LCD_X_DOT, LCD_Y_DOT,
	ACT_MAKE | ACT_MOVE | ACT_MOVE_IN | ACT_MOVE_OUT | ACT_BREAK | ACT_500MSEC,
	OBJ_IC_GAMEAREA,
	0x0000,

	0, 0, 0, 0,
	ACT_NONE,
	OBJ_END,
	0x0000
};

/*****************************************************************************/
word	MPdEdt[] ={
			PDNTBLEND,
		};

word	MPdSys[] = {
			38,			/* Set_date/time		*/
			33,			/* Sound				*/
			39,			/* Format				*/
			34,			/* Capacity				*/
			35,			/* Memory_management	*/
/*			36,			/* Language				*/
			37,			/* Contrast				*/
			40,			/* Touch_Panel_Alignment*/
/*			41,			/* Data_communication	*/
			PDNTBLEND,
		};

word	MPdOpt[] = {
			PDNTBLEND,
		};

SLW_TBL ktb_s[3] = {{312,0},{313,1},{314,2}};


struct work_area	lifeinfo;



/******************************************************************************
*  [Title]			Puzzle(main)
*  [Arguments]		None
*  [ReturnVAL]		None
*******************************************************************************/
void main(void) {
	TCHSTS	tsts;
	int i;

	cur_size = 5;
	set_cur_size(cur_size);

	PuzzleInit();
	Disp( &lifeinfo, TRUE );

	LibTchInit();
	
	for(;;){
		LibTchWait( &tsts );
/*		if( tsts.ext==EXT_CODE_500MS) NextPosition(); ??? */
		switch( tsts.obj ) {
		case  OBJ_IC_NEW:			/* [NEW] */
			if(LibBlockIconClick( &TiconNew, &tsts , B_ICON_RIGHT ) == TRUE) {
	    			DataInit( &lifeinfo );
				Disp( &lifeinfo, FALSE );
			}
			break;

		case  OBJ_IC_START:			/* [START] */
			if(LibBlockIconClick( &TiconStart, &tsts , B_ICON_RIGHT ) == TRUE) {
				for(i=0;i<10;i++) NextPosition();
			}
			break;

		case  OBJ_IC_DIMEN:			/* [DIMEN] */
			if(LibBlockIconClick( &TiconDimen, &tsts , B_ICON_RIGHT ) == TRUE) {
				DimenSet();
			}
			break;

		case  OBJ_IC_SIZE:			/* [SIZE] */
			if(LibBlockIconClick( &TiconSize, &tsts , B_ICON_LEFT ) == TRUE) {
				GameSet();
			}
			break;


		case  OBJ_IC_GAMEAREA:
		        if( tsts.act!=ACT_MAKE ) break;
			DrawFish( &tsts );
			break;

		/** M-BAR **/
			case OBJ_HIC_MBAR:
				GmPdwnSet();				/* PullDownMenu */
				if( GmPdwnFnc() == TRUE ){
					PuzzleInit();	  		/* Initial */
					Disp( &lifeinfo, TRUE );
					LibTchInit();
				};
				break;

		default:
			break;
		}
		if(tsts.act == ACT_ALM)
			LibAlarm();	/* AlarmProc */
	}
}


/******************************************************************************
*	[Title]		Initial
*	[Arguments]	None
*	[ReturnVAL]	None
******************************************************************************/
static void PuzzleInit( void ) {

	PuzzleDisplay();
	PuzzleTchSet();
	srand( GetSeed() );			/* Randomize */
	DataInit( &lifeinfo );	/* DataInitial */
}

/******************************************************************************
*	[Title]		Touch Stack Push
*	[Arguments]	None
*	[ReturnVAL]	None
******************************************************************************/
static void PuzzleTchSet(void){

	LibTchStackClr();
	LibTchStackPush( NULL );
	LibTchStackPush( TchHardIcon );
	LibTchStackPush( TchHeaderIcon );
	LibTchStackPush( TchGameArea );
	LibTchStackPush( TchModeIcon );		/* Pop Up Tools */
}


/******************************************************************************
*	[Title]		InitialDisplay
*	[Arguments]	None
*	[ReturnVAL]	None
******************************************************************************/
void PuzzleDisplay(void){
	LibClrDisp();
	LibPutFarData(71,0,8);

 LibGdsBox(31,0,71,10);
 LibGdsLine(32,11,72,11); 
 LibGdsBox(1,0,31,10);
 LibGdsLine(2,11,32,11); 

	LibPutProStr(IB_PFONT1,104,2,"New",30);
	LibPutProStr(IB_PFONT1,74,2,"Set",30);
	LibPutProStr(IB_PFONT1,34,2,"Dimens",40);
	LibPutProStr(IB_PFONT1,4,2,"Start",31);
	LibModeIconDsp();		/* Pop Up Tools */
	LibPutDisp();
}


/******************************************************************************
*	[Title]		BoardInitial
*	[Arguments]	struct work_area *p
*	[ReturnVAL]	None
*******************************************************************************/
static void DataInit( struct work_area *p ) {

	int i,j;

	for(i=0; i<MAX_SIZE_X; i++)
		for(j=0;j<MAX_SIZE_Y;j++)
			p->board[i][j] = 0;
}

/******************************************************************************
*	[Title]		BouadInitialDisplay
*	[Arguments]	struct work_area *p
*	[ReturnVAL]	None
*******************************************************************************/
static void Disp( struct work_area *p, bool f ) {

	int		i,j;

/* grid */
if (f) {
	LibGdsClr( START_SCR_X, START_SCR_Y, LCD_X_DOT-1, LCD_Y_DOT-1);

	for(i=0; i<=MAX_SIZE_X; i++) {
	    LibGdsLine( i*game_size + START_SCR_X, START_SCR_Y,
	                i*game_size + START_SCR_X, START_SCR_Y + MAX_SIZE_Y*game_size );
	}
	for(i=0; i<=MAX_SIZE_Y; i++) {
	    LibGdsLine( START_SCR_X, i*game_size + START_SCR_Y, 
	                START_SCR_X + MAX_SIZE_X*game_size, i*game_size + START_SCR_Y );
	}
}

	for(i=0; i<MAX_SIZE_X; i++) {
		for(j=0; j<MAX_SIZE_Y; j++) {
			DispCard( i, j, p->board[i][j], FALSE );
		}
	}

	LibPutDisp();
}

/******************************************************************************
*	[Title]		ChipsDisplay
*	[Arguments]	int  x, y  --- DrawPosition(0`3)
*				int  n  --- ChipNumber(0`15 :0=Space)
*				bool f  --- ( TRUE:Display )
*	[ReturnVAL]	None
******************************************************************************/
static void DispCard( int x, int y, int n, bool f ) {

	int		x1,y1;

	x1 = x * game_size + START_SCR_X + 1;
	y1 = y * game_size + START_SCR_Y + 1;

	if( n!=0 ) {
		LibGdsLine(x1,y1,x1+game_size-2,y1+game_size-2);
		LibGdsLine(x1+game_size-2,y1,x1,y1+game_size-2);
	}
	else	{
		LibClrBox( x1,y1,game_size-1,game_size-1);
	}
	if(f)
		LibPutDispBox(x1,y1,game_size-1,game_size-1);
}

/******************************************************************************
*	[Title]		MoveChips
*	[Arguments]	TCHSTS *tsts : Touch Status
*	[ReturnVAL]	None
*******************************************************************************/
static void DrawFish( TCHSTS *tsts ) {
	int		x, y;
	
	x = (tsts->x - START_SCR_X) / game_size;
	y = (tsts->y - START_SCR_Y) / game_size;
	
	if (x>=0 && x<MAX_SIZE_X && y>=0 && y<MAX_SIZE_Y) {
	    lifeinfo.board[x][y] = 1 - lifeinfo.board[x][y];
	    DispCard(x, y, lifeinfo.board[x][y], TRUE);
	}
	
}


static void Num2( byte *p, int n ) {
	*p=(byte)(n/10)+'0';
	*(p+1)=(byte)(n%10)+'0';
}


/******************************************************************************
*	[Title]		RandomSeed(0<=VAL<=32768)
*	[Arguments]	None
*	[ReturnVAL]	RandomSeed
******************************************************************************/
static int GetSeed( void ) {
	int   s;
	long  hh, mm, ss;
	byte  stime[7];

	LibGetDateTimeM( stime );
	hh = (long)( (10*(stime[1]&0x0F) + (stime[2]&0x0F)) * 3600 );
	mm = (long)( (10*(stime[3]&0x0F) + (stime[4]&0x0F)) * 60 );
	ss = (long)( (10*(stime[5]&0x0F) + (stime[6]&0x0F)) );
	s = (int)( (hh+mm+ss)%32768 );
	return( s );
}

/******************************************************************************
	[Title]		PullDownMenuSetup
	[Arguments]	None
	[ReturnVAL]	None
******************************************************************************/
void GmPdwnSet(void)
{
	word	p_sys;

	LibPullDownInit(MPdEdt,MPdSys,MPdOpt);		/* MenuBAR Init */

 /* [System] */
	p_sys =  PULLDOWN_SYSTEM | 0x0100;
	LibPullDownAtrSet( PULLDOWN_HTNDSP, PULLDOWN_SYSTEM, p_sys);

}
/******************************************************************************
	[Title]		PullDownMenu Functions
	[Arguments]	None
	[ReturnVAL]	bool TRUE=Redisplay
******************************************************************************/
bool GmPdwnFnc()
{
	word	sel;
	bool	jdg = FALSE;

	sel = LibPullDown();		/* PullDownMenu */
	if(sel & PULLDOWN_SYSTEM)
		jdg = PdwnFncSys(sel);
	return(jdg);
}
/******************************************************************************
	[Title]		PullDownMenuFunction(system)
	[Arguments]	word Sel(select number)
	[ReturnVAL]	bool TRUE=Rediplay
******************************************************************************/
bool PdwnFncSys(word sel)
/*TAIL*/
{
	bool	jdg = FALSE;
	switch(sel){

		case PDWN_SYS_DTTM:		/* Set_date/time		*/
			LibFuncDateTime();
			break;

		case PDWN_SYS_SOUND:	/* Sound				*/
			LibFuncSound(0);
			break;

		case PDWN_SYS_FORMT:	/* Format				*/
			LibFuncFormat();
			break;

		case PDWN_SYS_CAPCT:	/* Capacity				*/
			LibFuncCapa();
			break;

		case PDWN_SYS_MMANE:	/* Memory_management	*/
			LibFuncMemoryManagement();
			break;

/*		case PDWN_SYS_LANG:		/* Language				*/
/*			if(LibFuncLang()==TRUE){					*/
/*				jdg = TRUE;								*/
/*			}											*/
/*			break;										*/

		case PDWN_SYS_CNTRS:	/* Contrast				*/
			LibFuncContrast();
			break;

		case PDWN_SYS_TPA:		/* Touch_Panel_Alignment*/
			LibFuncDigitizer();
			break;

		default:
			break;
	}
	return(jdg);
}


int get_numof(int i, int j)
{
    int a,b, a1,b1, numof;
    numof = 0;
    for(b=-1,b1=j-1;b<=1;b++,b1++) {
        if (b1<0) b1 = MAX_SIZE_Y-1;
        else if (b1>=MAX_SIZE_Y) b1=0;
        for(a=-1,a1=i-1;a<=1;a++,a1++) {
           if (a1<0) a1 = MAX_SIZE_X-1; /* do torus */
           else if (a1>=MAX_SIZE_X) a1=0;
           if (a==0 && b==0) continue; /* don't count itself */
           if ((lifeinfo.board[a1][b1]&1)!=0) numof++;
       }
    }
    return (numof);
}

void NextPosition(void)
{
    int i, j, k;
    for(i=0; i<MAX_SIZE_X; i++) {
	for(j=0;j<MAX_SIZE_Y;j++) {
	        k = get_numof(i, j);
		if (k==3 || (k==2 && lifeinfo.board[i][j]) ) {
		    lifeinfo.board[i][j] |= 2;
		} else {
		    lifeinfo.board[i][j] &= 1;
		}
	}
    }
    for(i=0; i<MAX_SIZE_X; i++) {
	for(j=0;j<MAX_SIZE_Y;j++) {
	   lifeinfo.board[i][j] >>= 1;
	}
    }
    Disp( &lifeinfo, FALSE );
}

static int data_line[] = {
  0, 0,
  1, 0,
  2, 0,
  3, 0,
  4, 0,
  5, 0,
  6, 0,
  7, 0, -1};

static int data_glider[] = {
  0, 2,
  1, 2,
  1, 0,
  2, 2,
  2, 1, -1};


static int data_kostik[] = {
  1, 1,
  1, 2,
  1, 3,
  1, 4,
  1, 5,
  1, 6,
  1, 7,

  2, 4,
  3, 3,
  3, 5,
  4, 2,
  4, 6,
  5, 1,
  5, 7,
  
  7, 2,
  7, 3,
  7, 4,
  7, 5,
  7, 6,

  8, 1,
  8, 7,
  9, 1,
  9, 7,
  10, 1,
  10, 7,

  11, 2,
  11, 3,
  11, 4,
  11, 5,
  11, 6,

   13, 2,
   13, 3,
   13, 4,
   13, 5,
   13, 6,

  14, 1,
  14, 7,
  15, 1,
  15, 7,

  16, 2,
  16, 6,

  1, 10,
  2, 10,
  3, 10,
  3, 11,
  3, 12,
  3, 13,
  3, 14,
  3, 15,
  3, 16,
  4, 10,
  5, 10,

  7, 10,
  7, 11,
  7, 12,
  7, 13,
  7, 14,
  7, 15,
  7, 16,

  8, 15,
  9, 14,

  10, 10,
  10, 11,
  10, 12,
  10, 13,
  10, 14,
  10, 15,
  10, 16,

  12, 10,
  12, 11,
  12, 12,
  12, 13,
  12, 14,
  12, 15,
  12, 16,

  13, 13,
  14, 12,
  14, 14,
  15, 11,
  15, 15,
  16, 10,
  16, 16,
  -1};

static void GameSet(void)
{
	int *mdata;
	int x,y, cx,cy;

	byte    rtv[MAX_LEVEL+1] = {0,1,2,3, 0xff, 5,6,7,0xff};
	byte    cmnt[MAX_LEVEL*(7+1)],np;
	SLW2_ST win_prm;
	byte    sel_ret;
	byte    t_tbl[MAX_LEVEL][7+1];
	int     i,k,len;

	/* data */
        strcpy(t_tbl[0], "Rand");
        strcpy(t_tbl[1], "Glider");
        strcpy(t_tbl[2], "Line");
        strcpy(t_tbl[3], "Kostik");

	/* initial */
	np = 0;

	/* disp Buff Making */
	for(i=k=0;i<MAX_LEVEL;i++,k++){
	    len = strlen(t_tbl[i]);
	    memcpy(&cmnt[k],t_tbl[i],len);
	    k += len;
	    if(i<1) cmnt[k] = 0xfe;
	    else    cmnt[k] = 0x00;     /* End Data */
	}

	/* select window */
	win_prm.x    =  70;
	win_prm.y    =  12;
	win_prm.xs   =  37;
	win_prm.ity  =   9;
	win_prm.np   = np;
	win_prm.cmnt = cmnt;
	win_prm.rtv  = rtv;
	win_prm.t_xs =   4;

	sel_ret = LibSelWindowExt(&win_prm);

	switch(sel_ret) {
		case 0:
			mdata = NULL;	/* Random */
		break;
		case 1:
			mdata = data_glider;
		break;
		case 2:
			mdata = data_line;
		break;
		case 3:
			mdata = data_kostik;
		break;
		default:
		   return;
	}
	

	if (mdata) {
/*	    DataInit(&lifeinfo); */
	    cx = cy = -1;
	    for(i=0;;i+=2) {
	      if (mdata[i]<0) break;
	      x = mdata[i];
	      y = mdata[i+1];
	      if (cx<0 || x>cx) cx=x;
	      if (cy<0 || y>cy) cy=y;
	    }
	    cx = MAX_SIZE_X/2 - cx/2;
	    cy = MAX_SIZE_Y/2 - cy/2;

	    for(i=0;;i+=2) {
	      if (mdata[i]<0) break;
	      x = mdata[i];
	      y = mdata[i+1];
	      lifeinfo.board[x + cx][y+cy] = 1;
	    }
	} else {
	      cx = MAX_SIZE_X * MAX_SIZE_Y / 4;
	      for(i=0;i<cx;i++) {
	      	  x = rand() % MAX_SIZE_X;
	      	  y = rand() % MAX_SIZE_Y;
	          lifeinfo.board[x][y] = 1;
	      }
	}

        Disp( &lifeinfo, FALSE );
}


static void DimenSet(void)
{
	byte    rtv[MAX_DIMEN+1];
	byte    cmnt[MAX_DIMEN*(7+1)],np;
	SLW2_ST win_prm;
	byte    sel_ret;
	byte    t_tbl[MAX_DIMEN][7+1];
	int     i,k,len;

	/* data */
	for(i=0;i<MAX_DIMEN;i++) {
	  rtv[i] = i;
	  set_cur_size(i);
          sprintf(t_tbl[i], "%d x %d", MAX_SIZE_X, MAX_SIZE_Y);
        }
        rtv[MAX_DIMEN] = 0xff;

	/* initial */
	np = cur_size;

	/* disp Buff Making */
	for(i=k=0;i<MAX_DIMEN;i++,k++){
	    len = strlen(t_tbl[i]);
	    memcpy(&cmnt[k],t_tbl[i],len);
	    k += len;
	    if(i<1) cmnt[k] = 0xfe;
	    else    cmnt[k] = 0x00;     /* End Data */
	}

	/* select window */
	win_prm.x    =  30;
	win_prm.y    =  12;
	win_prm.xs   =  48;
	win_prm.ity  =   9;
	win_prm.np   = np;
	win_prm.cmnt = cmnt;
	win_prm.rtv  = rtv;
	win_prm.t_xs =   4;

	sel_ret = LibSelWindowExt(&win_prm);
	
	if (sel_ret>=0 && sel_ret<MAX_DIMEN) {
	   cur_size = sel_ret;
	}
        set_cur_size(cur_size);
        Disp( &lifeinfo, TRUE );
}

static void set_cur_size(int sz)
{
   game_size = sz + 3;
   MAX_SIZE_X = SIZE_SCR_X / game_size;
   MAX_SIZE_Y = SIZE_SCR_Y / game_size;
   if (MAX_SIZE_X>THE_MAX_SIZE_X) MAX_SIZE_X = THE_MAX_SIZE_X;
   if (MAX_SIZE_Y>THE_MAX_SIZE_Y) MAX_SIZE_Y = THE_MAX_SIZE_Y;
}

